import {useNavigate } from 'react-router-dom';
import { Menubar } from 'primereact/menubar';
import { Image } from "primereact/image";
import logo from "../../../assets/images/logo.gif";

const DetailsMenu = () => {
    const navigate = useNavigate();
    const items = [
        {
            label: "Back",
            icon: 'pi pi-arrow-left',
            command: () => {
                navigate(-1) 
            }
        },
    ];


    return (
        <div className="menu-component">
            <div className="logo-container">
                <div className="logo-wrapper">
                    <Image src={logo} alt="" />
                </div>
            </div>
            <div className="menu-container">
                <Menubar
                    model={items}
                />
            </div>
        </div >
    );
}


export default DetailsMenu;