import config from "../../../config";

const pattern = config.restoreConfirm

const message = `type "${pattern}" here`;

const constraints = {
    targetDump: {
        presence: {
            message: "Dump is required field",
            allowEmpty: false
        }
    },
    restoreConfirm: {
        presence: {
            message: message,
            allowEmpty: false
        },
        format:
        {
            pattern: pattern,
            message: message
        },
    
    },
}

export default constraints;