import config from "../../../config";

const constraints = {
    username: {
        presence: {
            message: "Database Username is required field.",
            allowEmpty: false
        }
    },
    password: {
        presence: {
            message: "Password is required field.",
            allowEmpty: false
        },
        format: {
            pattern: config.passwordRegex,
            message: "Password has invalid format."
        }
    },
}

export default constraints;