import config from "../../../config";

const constraints = {
    name: {
        presence: {
            message: "Name is required field.",
            allowEmpty: false
        },
        exclusion: {
            within:  ["repmgr"],
          },
        length: {
            maximum: 31,
            tooLong: "max %{count} characters"
        },
        format:                                                         
        {
            pattern: config.postgresNameRegex,
            message: "Name has invalid format."
        }
    },
    
}

export default constraints;