import config from "../../../config";

const pattern = config.upgradeConfirm

const message = `type "${pattern}" here`;

const constraints = {
    targetVersion: {
        presence: {
            message: "Version is required field",
            allowEmpty: false
        }
    },
    upgradeConfirm: {
        presence: {
            message: message,
            allowEmpty: false
        },
        format:
        {
            pattern: pattern,
            message: message
        },
    
    },
}

export default constraints;