import config from "../../../config";

const constraints = {
    name: {
        presence: {
            message: "Name is required field.",
            allowEmpty: false
        },
        length: {
            maximum: 255,
            tooLong: "max %{count} characters"
        },
        format:                                                         
        {
            pattern: config.elastisearchNameRegex,
            message: "Name has invalid format."
        }
    },
    targetSentinel: {
        presence: {
            message: "Sentinel is required field",
            allowEmpty: false
        }
    },
    targetMaster: {
        presence: {
            message: "Master is required field",
            allowEmpty: false
        }
    },
}

export default constraints;