import config from "../../config";
const constraints = {
    username: {
        presence: {
            message: "The Username cannot be empty",
            allowEmpty: false
        },
        format: {
            pattern: config.usernameRegex,
            message: "Username has invalid format."
        }
    },
    org_name: {
        presence: {
            message: "Organization name cannot be empty",
            allowEmpty: false
        }
    },
    password: {
        presence: {
            message: "The Password cannot be empty"
        }
    }
}
export default constraints;