import { Button } from "primereact/button";
import { useNavigate } from "react-router-dom";
const Page404 = () => {
    const navigate = useNavigate();
    return (
        <div className="page-404">
        <div className="page-404-body">
        <div className="content">
           <h2 className="header" data-text="404">
              404
           </h2>
           <h4 data-text="Opps! Page not found">
              Oops! Page not found
           </h4>
           <p>
              Sorry, the page you're looking for doesn't exist. If you think something is broken, report a problem.
           </p>
           <div className="btns">

           <Button className="mr-1" severity="secondary" size="large" onClick={() => navigate("/")}>return home</Button>
              <Button className="ml-1" severity="info" size="large" onClick={() => navigate("/")}>report a problem</Button>

           </div>
        </div>

        </div>
       
     </div>
    );
}
export default Page404;
