import axios from "axios";
import config from "../../config";
const addMongoPod = async (accessToken, data) => {
    const url = `${config.apiUrl}/kubernetes/api/create_mongo_master/`;
    let error_data = false;
    const res = await axios.post(url, JSON.stringify(data),
        {
            headers: {
                "Content-Type": "application/json",
                "Authorization": "Bearer " + accessToken
            }
        }).catch(function (error) {
            if (error.response) {
                error_data = error.response
            }});
    return error_data ? error_data : res?.data;
}

const apiMongoKubernetes = 
{
    addMongoPod,
 
}
export default apiMongoKubernetes;