INSERT INTO app_123monitor.rp_monitors (org_id,node_id,db_type,monitor_name,monitor_description,pre_script,monitor_script,ind_enabled,red_rule,yellow_rule,red_rule_message,yellow_rule_message,ind_send_email_notifications,monitor_interval,runtime_red_threshold,runtime_yellow_threshold,return_code_threshold,ind_status_graph,ind_create_timeline,ind_timeline_full_impact,cmd_type,ind_first_column_unique,ind_alert_on_added_missing,alert_on_added_missing_severity,ind_alert_compare_to_previous_check,alert_compare_to_previous_check_severity,alert_compare_to_previous_check_higher_lower,alert_compare_to_previous_check_percent,ind_break_long_running,ind_compute_baseline,data_reduction_function,renew_alert_every,ind_red_by_row_count,red_by_row_count_option,red_by_row_count_items,ind_yellow_by_row_count,yellow_by_row_count_option,yellow_by_row_count_items,graph_aggregation,graph_aggregation_column,snoozed_until,count_long_running,ind_broken,num_weeks_in_baseline,task_id,"module") VALUES
	 (1,NULL,'LINUX','linux performance counters','','','mem=`free |grep Mem|awk ''{print $3"@@"$2}''` 
swap=`free |grep Swap|awk ''{print $3"@@"$2}''` 
cu=`sar 1 1 | grep Average | awk ''{print u$3+$5"@@"0+$6}''` 
cpuc=`cat /proc/cpuinfo |grep processor|wc -l` 
info=`echo $cu"@@"$mem"@@"$cpuc"@@"$swap`
echo ''metric@@''$info','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','15 minutes',60000,30000,'','N','Y','Y','ssh','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'LINUX','config files','configuration files of linux machine','','import subprocess

pathToFiles = [
    ''/etc/hosts'', 
    ''/etc/resolv.conf'', 
    ''/etc/sysconfig/network'', 
    ''/etc/sysctl.conf'', 
    ''/etc/passwd'', 
    ''/etc/shadow'', 
    ''/etc/group'',
    ''/etc/grub.d'',
    ''/etc/init.d'',
    ''/etc/fstab'',
    ''/etc/inittab'',
    ''/etc/shutdown.allow''
]

for pathToFile in pathToFiles:
    command = ''ls -lhd --time-style=long-iso %s'' %pathToFile
    p = subprocess.run(command, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    info = p.stdout.decode("utf-8").strip()
    err = p.stderr.decode("utf-8").strip()
    if err and err.find (''No such file'') > 0 :
        print(''%s@@The File Does Not Exist'' %pathToFile)
        continue

    if info:
        z = info.split()
        list = ''Permissions'',''Owner'',''Group'',''Size'',''Modification''
        new = z[0],z[2],z[3],z[4],z[6]+'' ''+z[5]
        print(pathToFile, end=''@@'')
        print(''@@''.join(new))','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','ssh','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'security'),
	 (1,NULL,'LINUX','Blocked Processes','','','import subprocess, re

command = ''top -b -n 1 | grep Tasks && grep blocked /proc/stat''
processes = subprocess.run(command, shell=True, stdout=subprocess.PIPE).stdout.decode("utf-8").strip()
tasks = re.sub('','',''@@'',processes)
print("Blocked@@",processes.strip('''')[-1])','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 minute',10000,2000,'','N','Y','Y','ssh','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,''),
	 (1,NULL,'MARIADB','mariadb statistics','','','SELECT variable_name, 
       variable_value, 
       (@total := @total + variable_value) AS total
FROM (SELECT variable_name, variable_value
      FROM information_schema.global_status
      WHERE variable_name LIKE ''Com_insert''
         OR variable_name LIKE ''Com_update''
         OR variable_name LIKE ''Com_delete''
      ORDER BY variable_name) AS t,
     (SELECT @total := 0) AS init','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 minute',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MARIADB','mariadb replication status','mariadb replication connection status','','SHOW STATUS LIKE ''Slave_running'';','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 minute',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'MARIADB','mariadb all databases sizes','sizes of all mariadb instance databases','','SELECT table_schema AS ''Database'', ROUND(SUM(data_length + index_length) / 1024 / 1024, 2) AS ''Size(MB)'' FROM information_schema.tables GROUP BY table_schema
UNION
SELECT ''Total Size'' AS ''Database'', ROUND(SUM(data_length + index_length) / 1024 / 1024, 2) AS ''Size(MB)'' FROM information_schema.tables;','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MARIADB','mariadb buffer pool size','size of innodb buffers','','SELECT 
    SUBSTRING_INDEX(SUBSTRING_INDEX(VARIABLE_VALUE, '' '', 3), '' '', -1) AS total_memory_allocated,
    SUBSTRING_INDEX(SUBSTRING_INDEX(VARIABLE_VALUE, '' '', 5), '' '', -1) AS buffer_pool_size,
    SUBSTRING_INDEX(SUBSTRING_INDEX(VARIABLE_VALUE, '' '', 7), '' '', -1) AS free_buffers,
    SUBSTRING_INDEX(SUBSTRING_INDEX(VARIABLE_VALUE, '' '', 9), '' '', -1) AS database_pages
FROM information_schema.GLOBAL_STATUS
WHERE VARIABLE_NAME IN (''Innodb_buffer_pool_memory_allocated'', ''Innodb_buffer_pool_free_buffers'', ''Innodb_buffer_pool_pages_total'');','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 minute',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MARIADB','mariadb connections','mariadb used connections percent','','SELECT 
    ROUND((COUNT(*) / (@@max_connections + COUNT(*))) * 100) AS ''used_percent'', 
    CAST(CONCAT(COUNT(*), '' of '', @@max_connections, '' connections used'') AS CHAR) AS ''monitor_message''
FROM 
    information_schema.processlist;','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','15 minutes',60000,30000,' ','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MARIADB','mariadb uptime','uptime of  mariadb instance','','SHOW GLOBAL STATUS LIKE ''Uptime'';','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'MARIADB','users','list mariadb instance users','','SELECT User FROM mysql.user;','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'security');
INSERT INTO app_123monitor.rp_monitors (org_id,node_id,db_type,monitor_name,monitor_description,pre_script,monitor_script,ind_enabled,red_rule,yellow_rule,red_rule_message,yellow_rule_message,ind_send_email_notifications,monitor_interval,runtime_red_threshold,runtime_yellow_threshold,return_code_threshold,ind_status_graph,ind_create_timeline,ind_timeline_full_impact,cmd_type,ind_first_column_unique,ind_alert_on_added_missing,alert_on_added_missing_severity,ind_alert_compare_to_previous_check,alert_compare_to_previous_check_severity,alert_compare_to_previous_check_higher_lower,alert_compare_to_previous_check_percent,ind_break_long_running,ind_compute_baseline,data_reduction_function,renew_alert_every,ind_red_by_row_count,red_by_row_count_option,red_by_row_count_items,ind_yellow_by_row_count,yellow_by_row_count_option,yellow_by_row_count_items,graph_aggregation,graph_aggregation_column,snoozed_until,count_long_running,ind_broken,num_weeks_in_baseline,task_id,"module") VALUES
	 (1,NULL,'MARIADB','mariadb version','get version of mariadb  instance','','SELECT version();','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'MONGO','lag','mongo replication lag','','rs.status().members.forEach(function(member) {
    var host = member.name.split(":")[0];
    var port = member.name.split(":")[1];
    var nodeType = member.stateStr;
    var slaveDelay = member.slaveDelay;

    if(nodeType === "SECONDARY") {
        var primaryOpTime = rs.status().members.find(function(node) { return node.stateStr === ''PRIMARY'' }).optime.t;
        var timeLag = (primaryOpTime - member.optime.t)/1000;
        print(`${host}@@${port}${nodeType}@@Lag is ${timeLag} seconds`);
    } else {
        print(`${host}@@${port}${nodeType}@@Only secondary can have lag`);
    }
});','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 minute',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'MONGO','oplog','mongo oplog','','const oplogCollectionName = "oplog.rs";
const localDB = db.getSiblingDB("local");
var stats = localDB.runCommand({ collStats: oplogCollectionName });
const ol_size = stats.size;
const ol_storage_size = stats.storageSize;
const ol_used_storage = Math.floor((ol_size / ol_storage_size) * 100);
const oplog = localDB.getCollection(oplogCollectionName);
var firstDoc = oplog.find().sort({ $natural: 1 }).limit(1).next();
var lastDoc = oplog.find().sort({ $natural: -1 }).limit(1).next();
function getTimestampInMs(ts) {
  if (typeof ts.getTime === "function") {
    return ts.getTime();
  }
  if (ts.t) {
    return new Date(ts.t * 1000).getTime();
  }
  throw new Error("Unknown timestamp format");
}
const firstTime = getTimestampInMs(firstDoc.ts);
const lastTime = getTimestampInMs(lastDoc.ts);
const time_in_oplog = lastTime - firstTime;
const hours_in_oplog = time_in_oplog / (60 * 60 * 1000);
const approx_level = (hours_in_oplog * 100) / ol_used_storage;
const message = `Oplog saves ${time_in_oplog} ms, ${ol_used_storage}% used`;
print(`${Math.round(approx_level * 100) / 100}@@${message}`);','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','15 minutes',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MONGO','uptime','uptime of mongo instance','','print(db.adminCommand({ serverStatus: 1 }).uptime);','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'MONGO','mongo all database sizes','all mongo database sizes','','db.getMongo().setReadPref(''primaryPreferred'');
var db_names = db.getMongo().getDBNames();
var total_storage_size = 0;
var message = "";

db_names.forEach(function(db_name) {
    var db_sibling = db.getSiblingDB(db_name);
    var data = db_sibling.runCommand({ dbstats: 1 });

    var storage_size = (data.storageSize || 0) / 1024 / 1024;
    storage_size = parseFloat(storage_size.toFixed(1));

    message += `${db_name}@@${storage_size}\n`;
    total_storage_size += storage_size;
});

message += `Total@@${total_storage_size.toFixed(1)}`;
print(message);','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','N','N','sql','Y','Y',3,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MONGO','logs','Logs of mongo instance','','var limit = 0;
var logs = db.runCommand({ getLog: "global" });
logs.log.reverse().forEach(function(log) {
    if (limit < 2) {
        if(parseFloat(db.version()) >= 5.0){
            log =  JSON.parse(log);

        }
        else{
            log = tojson(log);
        }
        if ([''F'', ''E'', ''W''].includes(log.s)) {
            limit += 1;
            print(`${new Date(log.t.$date).toLocaleString().replace(/\s+/g,'' '')}@@${db.runCommand({ serverStatus: 1 }).host}@@${log.id}@@${log.s}@@${log.msg}`);
        }
    } else {
        return;
    }
});
','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','15 minutes',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'security'),
	 (1,NULL,'MONGO','mongo version','version of mongodb instance','','db.version();','Y','1=2','1=1','This is a red alert','This is a yellow alert','N','15 minutes',60000,30000,'','N','N','N','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'MONGO','memcheck','check mongo RAM usage','','var mem_status = db.runCommand({"serverStatus": 1}).mem;  
print(`${mem_status.resident}@@${mem_status.virtual}`);','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 minute',60000,30000,'','Y','Y','Y','sql','N','N',2,'N',3,'higher',50,'Y','N','average','day','N','above',0,'N','above',0,'maximum','virtual',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MONGO','users','List mongo users','  ','db.getMongo().setReadPref(''primaryPreferred'');
var db_list = db.getMongo().getDBNames();
for (var i = 0; i < db_list.length; i++) {
  var db_name = db_list[i];
  var users_list = db.getSiblingDB(db_name).runCommand({usersInfo: 1}).users;
  for (var j = 0; j < users_list.length; j++) {
    var user = users_list[j];
    var user_id = user.userId.toString(''hex'');
    print(user._id + ''@@'' + user_id);
  }
}','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'security'),
	 (1,NULL,'MONGO','mongo oplog latency','statistics of mongodb instance oplog updates','','const data = db.adminCommand("serverStatus")[''opLatencies''];

function calculateRatio(latency, ops) {
    return ops > 0 ? (parseInt(latency) / parseInt(ops)).toFixed(2) : "0";
}

const latencyReads = calculateRatio(data[''reads''][''latency''], data[''reads''][''ops'']);
const latencyWrites = calculateRatio(data[''writes''][''latency''], data[''writes''][''ops'']);
const latencyCommands = calculateRatio(data[''commands''][''latency''], data[''commands''][''ops'']);
const latencyTransactions = calculateRatio(data[''transactions''][''latency''], data[''transactions''][''ops'']);

print(`${latencyReads}@@${latencyWrites}@@${latencyCommands}@@${latencyTransactions}`);','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 minute',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance');
INSERT INTO app_123monitor.rp_monitors (org_id,node_id,db_type,monitor_name,monitor_description,pre_script,monitor_script,ind_enabled,red_rule,yellow_rule,red_rule_message,yellow_rule_message,ind_send_email_notifications,monitor_interval,runtime_red_threshold,runtime_yellow_threshold,return_code_threshold,ind_status_graph,ind_create_timeline,ind_timeline_full_impact,cmd_type,ind_first_column_unique,ind_alert_on_added_missing,alert_on_added_missing_severity,ind_alert_compare_to_previous_check,alert_compare_to_previous_check_severity,alert_compare_to_previous_check_higher_lower,alert_compare_to_previous_check_percent,ind_break_long_running,ind_compute_baseline,data_reduction_function,renew_alert_every,ind_red_by_row_count,red_by_row_count_option,red_by_row_count_items,ind_yellow_by_row_count,yellow_by_row_count_option,yellow_by_row_count_items,graph_aggregation,graph_aggregation_column,snoozed_until,count_long_running,ind_broken,num_weeks_in_baseline,task_id,"module") VALUES
	 (1,NULL,'MONGO','memcheck unique','','','var mem_status = db.runCommand({"serverStatus": 1}).mem;
print(`resident@@${mem_status.resident}`);
print(`virtual@@${mem_status.virtual}`);
','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 minute',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MONGO','mongo queries','Number of mongodb read/write queries','','var status = db.runCommand({"serverStatus": 1});
var queue = status.globalLock?.currentQueue || { total: 0, readers: 0, writers: 0 };
print(`${queue.total}@@${queue.readers}@@${queue.writers}`);','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MONGO','mongo local time','local time of mongodb instance','','db.runCommand({"serverStatus": 1}).localTime.toLocaleString().replace(/\s+/g,'' '');','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'MONGO','mongo collections sizes','All mongodb instance collection sizes ','','db.getMongo().setReadPref(''primaryPreferred'');
var db_names = db.getMongo().getDBNames();

db_names.forEach(function(db_name) {
    var db_sibling = db.getSiblingDB(db_name);
    var collections = db_sibling.getCollectionInfos();
    
    collections.forEach(function(col) {
        if (!col.type || col.type === ''collection'') {
            var data = db_sibling.runCommand({collStats: col.name});
            if (data.ok) {
                print(`${db_name}.${col.name}@@${data.size}`);
            } 
            // else {
            //     print(`${db_name}.${col.name}@@ERROR: ${data.errmsg}`);
            // }
        }
    });
});','Y','1=2','1=1','This is a red alert','This is a yellow alert','N','1 hour',60000,30000,'','N','N','N','sql','Y','Y',3,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MONGO','replication status','mongo oplog status','','const oplogcol = db.getSiblingDB("local").oplog.rs;
const tsfirst = oplogcol.find().sort({$natural: 1}).limit(1).next().ts;
const tslast = oplogcol.find().sort({$natural: -1}).limit(1).next().ts;

const timediff = tslast.time - tsfirst.time;
const timediffhours = Math.round((timediff / 3600) * 100) / 100;

const collstats = db.getSiblingDB("local").runCommand({"collstats": "oplog.rs"});
const logsizemb = Math.round((collstats.maxSize / (1024 * 1024)) * 100) / 100;
const usedmb = Math.round((collstats.size / (1024 * 1024)) * 100) / 100;

print(`${logsizemb}@@${usedmb}@@${timediffhours}`);','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 minute',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'MONGO','mongo page faults','mongo ram page faults','','var serverStatus = db.runCommand({serverStatus: 1});
// calculate page faults per second
var pageFaultsPerSecond = serverStatus.extra_info.page_faults / serverStatus.uptime;
print(pageFaultsPerSecond.toFixed(2));','Y','column1::numeric>100','column1::numeric>10','This is a red alert','This is a yellow alert','Y','1 minute',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MYSQL','mysql uptime','uptime of mysql instance','','SHOW GLOBAL STATUS LIKE ''Uptime'';','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'MYSQL','mysql statistics','mysql dml statistics','','SELECT event_name AS variable_name,        COUNT_STAR AS variable_value,        (@total := @total + COUNT_STAR) AS total FROM performance_schema.events_statements_summary_global_by_event_name WHERE event_name IN (''statement/sql/insert'', ''statement/sql/update'', ''statement/sql/delete'') ORDER BY event_name;
','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','15 minutes',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MYSQL','mysql version','version of mysql instance','','SELECT version();','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'MYSQL','mysql buffer pool size','size of innodb buffers','','SELECT 
    SUBSTRING_INDEX(SUBSTRING_INDEX(VARIABLE_VALUE, '' '', 3), '' '', -1) AS total_memory_allocated,
    SUBSTRING_INDEX(SUBSTRING_INDEX(VARIABLE_VALUE, '' '', 5), '' '', -1) AS buffer_pool_size,
    SUBSTRING_INDEX(SUBSTRING_INDEX(VARIABLE_VALUE, '' '', 7), '' '', -1) AS free_buffers,
    SUBSTRING_INDEX(SUBSTRING_INDEX(VARIABLE_VALUE, '' '', 9), '' '', -1) AS database_pages
FROM information_schema.GLOBAL_STATUS
WHERE VARIABLE_NAME IN (''Innodb_buffer_pool_memory_allocated'', ''Innodb_buffer_pool_free_buffers'', ''Innodb_buffer_pool_pages_total'');','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 minute',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance');
INSERT INTO app_123monitor.rp_monitors (org_id,node_id,db_type,monitor_name,monitor_description,pre_script,monitor_script,ind_enabled,red_rule,yellow_rule,red_rule_message,yellow_rule_message,ind_send_email_notifications,monitor_interval,runtime_red_threshold,runtime_yellow_threshold,return_code_threshold,ind_status_graph,ind_create_timeline,ind_timeline_full_impact,cmd_type,ind_first_column_unique,ind_alert_on_added_missing,alert_on_added_missing_severity,ind_alert_compare_to_previous_check,alert_compare_to_previous_check_severity,alert_compare_to_previous_check_higher_lower,alert_compare_to_previous_check_percent,ind_break_long_running,ind_compute_baseline,data_reduction_function,renew_alert_every,ind_red_by_row_count,red_by_row_count_option,red_by_row_count_items,ind_yellow_by_row_count,yellow_by_row_count_option,yellow_by_row_count_items,graph_aggregation,graph_aggregation_column,snoozed_until,count_long_running,ind_broken,num_weeks_in_baseline,task_id,"module") VALUES
	 (1,NULL,'MYSQL','mysql all database sizes','sizes of all mysql databases','','SELECT table_schema AS ''Database'', ROUND(SUM(data_length + index_length) / 1024 / 1024, 2) AS ''Size(MB)'' FROM information_schema.tables GROUP BY table_schema
UNION
SELECT ''Total Size'' AS ''Database'', ROUND(SUM(data_length + index_length) / 1024 / 1024, 2) AS ''Size(MB)'' FROM information_schema.tables;','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MYSQL','mysql connections','mysql connections','','SELECT 
    ROUND((COUNT(*) / (@@max_connections + COUNT(*))) * 100) AS ''used_percent'', 
    CAST(CONCAT(COUNT(*), '' of '', @@max_connections, '' connections used'') AS CHAR) AS ''monitor_message''
FROM 
    information_schema.processlist;','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','15 minutes',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'MYSQL','replication status','','','SELECT ''replication_connection_status'' AS source, SERVICE_STATE 
FROM performance_schema.replication_connection_status
UNION ALL
SELECT ''replication_applier_status'' AS source, SERVICE_STATE 
FROM performance_schema.replication_applier_status;','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 minute',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'MYSQL','mysql users','list users of mysql instance','','SELECT User FROM mysql.user;','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'security'),
	 (1,NULL,'POSTGRES','parameters pending restart','Detects configuration parameters that require PostgreSQL restart to take effect.','','SELECT name, setting, context FROM pg_settings WHERE pending_restart=true','Y','1=2','1=1','This is a red alert','PostgreSQL restart required for parameter','Y','15 minutes',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','added/missing replication subscriptions','List all replication subscriptions in the postgres cluster and alert if a replication subscription is added or missing compared to the previous check.','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"\\l\" -t" | cut -f1 -d "|" | grep -v template | grep -v "^$")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"SELECT ''$db''||''.''||subname||''.''||subowner, subpublications FROM pg_catalog.pg_subscription\" -t | tr -d \"|\" | grep -v \"^$\" | sed -e ''s/^[ \t]*//''"
done','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','added/missing extensions','List all extensions in the postgres cluster and alert if a extension is added or missing compared to the previous check.','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"\\l\" -t" | cut -f1 -d "|" | grep -v template | grep -v "^$")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"SELECT ''$db''||''.''||e.extname||''.''||e.extversion||''.''||n.nspname, c.description FROM pg_catalog.pg_extension e LEFT JOIN pg_catalog.pg_namespace n ON n.oid = e.extnamespace LEFT JOIN pg_catalog.pg_description c ON c.objoid = e.oid AND c.classoid = ''pg_catalog.pg_extension''::pg_catalog.regclass ORDER BY 1\" -t | tr -d \"|\" | grep -v \"^$\" | sed -e ''s/^[ \t]*//''"
done','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','alert log','Check the postgres log and alert on ERROR/FATAL/PANIC','DO $$ 
BEGIN
	CREATE TABLE IF NOT EXISTS current_log_offset(id INT PRIMARY KEY, offst BIGINT, difference_offst BIGINT);
  INSERT INTO current_log_offset (id, offst, difference_offst) VALUES (1, (SELECT size FROM pg_stat_file(pg_current_logfile())), (SELECT size FROM pg_stat_file(pg_current_logfile())))
  ON CONFLICT (id) DO UPDATE SET difference_offst=(SELECT size-offst FROM pg_stat_file(pg_current_logfile()),current_log_offset),
  offst=(SELECT size FROM pg_stat_file(pg_current_logfile())); 
END $$;','SELECT CASE
           WHEN "unnest" SIMILAR TO ''%ERROR%'' THEN ''ERROR''
           WHEN "unnest" SIMILAR TO ''%FATAL%'' THEN ''FATAL''
           WHEN "unnest" SIMILAR TO ''%PANIC%'' THEN ''PANIC''
       END status, "unnest" FROM unnest(string_to_array(
(SELECT pg_read_file 
FROM pg_read_file (pg_current_logfile(),(SELECT offst-difference_offst FROM current_log_offset),(SELECT difference_offst FROM current_log_offset))), E''\n''))
WHERE "unnest" SIMILAR TO ''%(ERROR|FATAL|PANIC)%'' LIMIT 100','Y','status in (''PANIC'', ''FATAL'')','status in (''ERROR'')','PANIC/FATAL','ERROR','Y','15 minutes',60000,30000,'','N','Y','Y','sql','Y','Y',3,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'security'),
	 (1,NULL,'POSTGRES','added/missing materialized views','List all materialized views in the postgres cluster and alert if a materialized view is added or missing compared to the previous check.','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"\\l\" -t" | cut -f1 -d "|" | grep -v template | grep -v "^$")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"
        SELECT 
            ''$db'' || ''.'' || schemaname || ''.'' || matviewname AS matview_id,
            ispopulated,
            definition
        FROM pg_matviews
        ORDER BY schemaname, matviewname
    \" -t | tr -d \"|\" | grep -v \"^$\" | sed -e ''s/^[ \t]*//''"
done','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','added/missing indexes','List all indexes in the postgres cluster and alert if a index is added or missing compared to the previous check.','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -qAt -c \"SELECT datname FROM pg_database WHERE datistemplate = false\"")
do
  sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -qAt -c \"
    SET client_min_messages TO WARNING;

    CREATE TABLE IF NOT EXISTS monitor_indexes_snapshot (
      schemaname TEXT,
      tablename TEXT,
      indexname TEXT,
      PRIMARY KEY (schemaname, tablename, indexname)
    );

    WITH current_indexes AS (
      SELECT schemaname, tablename, indexname
      FROM pg_indexes
      WHERE schemaname NOT LIKE ''pg_%'' AND schemaname != ''information_schema''
    ),
    new_indexes AS (
      SELECT schemaname, tablename, indexname, ''new'' AS status
      FROM current_indexes
      EXCEPT
      SELECT schemaname, tablename, indexname, ''new'' FROM monitor_indexes_snapshot
    ),
    dropped_indexes AS (
      SELECT schemaname, tablename, indexname, ''dropped'' AS status
      FROM monitor_indexes_snapshot
      EXCEPT
      SELECT schemaname, tablename, indexname, ''dropped'' FROM current_indexes
    )
    SELECT ''$db.'' || schemaname || ''.'' || tablename || ''.'' || indexname AS index_name, status
    FROM new_indexes
    UNION ALL
    SELECT ''$db.'' || schemaname || ''.'' || tablename || ''.'' || indexname, status
    FROM dropped_indexes;

    TRUNCATE monitor_indexes_snapshot;
    INSERT INTO monitor_indexes_snapshot
    SELECT schemaname, tablename, indexname
    FROM pg_indexes
    WHERE schemaname NOT LIKE ''pg_%'' AND schemaname != ''information_schema'';
  \""
done','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra');
INSERT INTO app_123monitor.rp_monitors (org_id,node_id,db_type,monitor_name,monitor_description,pre_script,monitor_script,ind_enabled,red_rule,yellow_rule,red_rule_message,yellow_rule_message,ind_send_email_notifications,monitor_interval,runtime_red_threshold,runtime_yellow_threshold,return_code_threshold,ind_status_graph,ind_create_timeline,ind_timeline_full_impact,cmd_type,ind_first_column_unique,ind_alert_on_added_missing,alert_on_added_missing_severity,ind_alert_compare_to_previous_check,alert_compare_to_previous_check_severity,alert_compare_to_previous_check_higher_lower,alert_compare_to_previous_check_percent,ind_break_long_running,ind_compute_baseline,data_reduction_function,renew_alert_every,ind_red_by_row_count,red_by_row_count_option,red_by_row_count_items,ind_yellow_by_row_count,yellow_by_row_count_option,yellow_by_row_count_items,graph_aggregation,graph_aggregation_column,snoozed_until,count_long_running,ind_broken,num_weeks_in_baseline,task_id,"module") VALUES
	 (1,NULL,'POSTGRES','added/missing event triggers','List all event triggers in the postgres cluster and alert if a event trigger is added or missing compared to the previous check.','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"\\l\" -t" | cut -f1 -d "|" | grep -v template | grep -v "^$")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"SELECT ''$db''||''.''||evtname||''.''||evtevent ||''.''||evtowner FROM pg_event_trigger\" -t | tr -d \"|\" | grep -v \"^$\" | sed -e ''s/^[ \t]*//''"
done','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','btree bloat','Estimate bloat on B-tree indexes','','SELECT
    current_database() || ''.'' || nspname || ''.'' || idxname AS index_name,
    tblname AS table_name,
    bs * (relpages)::BIGINT AS total_bytes,
    bs * (relpages - est_pages_ff) AS wasted_bytes,
    ROUND(100 * (relpages - est_pages_ff)::FLOAT / relpages) AS bloat_ratio
FROM (
    SELECT
        COALESCE(1 + CEIL(reltuples / FLOOR((bs - pageopqdata - pagehdr) / (4 + nulldatahdrwidth)::FLOAT)), 0) AS est_pages,
        COALESCE(1 + CEIL(reltuples / FLOOR((bs - pageopqdata - pagehdr) * fillfactor / (100 * (4 + nulldatahdrwidth)::FLOAT))), 0) AS est_pages_ff,
        bs,
        nspname,
        tblname,
        idxname,
        relpages,
        fillfactor,
        is_na
    FROM (
        SELECT
            maxalign,
            bs,
            nspname,
            tblname,
            idxname,
            reltuples,
            relpages,
            relam,
            fillfactor,
            (
                index_tuple_hdr_bm + maxalign - CASE WHEN index_tuple_hdr_bm % maxalign = 0 THEN maxalign ELSE index_tuple_hdr_bm % maxalign END + nulldatawidth + maxalign - CASE WHEN nulldatawidth = 0 THEN 0 WHEN nulldatawidth::NUMERIC % maxalign = 0 THEN maxalign ELSE nulldatawidth::NUMERIC % maxalign END
            )::NUMERIC AS nulldatahdrwidth,
            pagehdr,
            pageopqdata,
            is_na
        FROM (
            SELECT
                n.nspname,
                sub.tblname,
                sub.idxname,
                sub.reltuples,
                sub.relpages,
                sub.relam,
                sub.fillfactor,
                current_setting(''block_size'')::NUMERIC AS bs,
                CASE
                    WHEN version() ~ ''mingw32'' OR version() ~ ''64-bit|x86_64|ppc64|ia64|amd64'' THEN 8
                    ELSE 4
                END AS maxalign,
                24 AS pagehdr,
                16 AS pageopqdata,
                CASE
                    WHEN MAX(COALESCE(sub.stanullfrac, 0)) = 0 THEN 2
                    ELSE 2 + ((32 + 8 - 1) / 8)
                END AS index_tuple_hdr_bm,
                SUM((1 - COALESCE(sub.stanullfrac, 0)) * COALESCE(sub.stawidth, 1024)) AS nulldatawidth,
                MAX(CASE WHEN a.atttypid = ''pg_catalog.name''::regtype THEN 1 ELSE 0 END) > 0 AS is_na
            FROM (
                SELECT
                    ct.relnamespace,
                    ct.relname AS tblname,
                    ci.relname AS idxname,
                    ci.reltuples,
                    ci.relpages,
                    ci.relam,
                    s.stawidth,
                    s.stanullfrac,
                    s.starelid,
                    s.staattnum,
                    COALESCE(substring(array_to_string(ci.reloptions, '' '') FROM ''fillfactor=([0-9]+)'')::SMALLINT, 90) AS fillfactor
                FROM
                    pg_catalog.pg_index AS i
                    JOIN pg_catalog.pg_class AS ci ON ci.oid = i.indexrelid
                    JOIN pg_catalog.pg_class AS ct ON i.indrelid = ct.oid
                    JOIN pg_catalog.pg_statistic AS s ON i.indexrelid = s.starelid
                WHERE
                    ci.relpages > 0
                UNION
                SELECT
                    ct.relnamespace,
                    ct.relname AS tblname,
                    ci.relname AS idxname,
                    ci.reltuples,
                    ci.relpages,
                    ci.relam,
                    s.stawidth,
                    s.stanullfrac,
                    s.starelid,
                    s.staattnum,
                    COALESCE(substring(array_to_string(ci.reloptions, '' '') FROM ''fillfactor=([0-9]+)'')::smallint, 90) AS fillfactor
                FROM
                    pg_catalog.pg_index AS i
                    JOIN pg_catalog.pg_class AS ci ON ci.oid = i.indexrelid
                    JOIN pg_catalog.pg_class AS ct ON ct.oid = i.indrelid
                    JOIN pg_catalog.pg_statistic AS s ON s.starelid = i.indrelid
                    AND s.staattnum = ANY (i.indkey)
                WHERE
                    ci.relpages > 0
            ) AS sub
            JOIN pg_catalog.pg_attribute AS a ON sub.starelid = a.attrelid
            AND sub.staattnum = a.attnum
            JOIN pg_catalog.pg_type AS t ON a.atttypid = t.oid
            JOIN pg_catalog.pg_namespace AS n ON sub.relnamespace = n.oid
            WHERE
                a.attnum > 0
            GROUP BY
                1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11
        ) AS sub2
    ) AS sub3
    JOIN pg_am am ON sub3.relam = am.oid
    WHERE
        am.amname = ''btree''
) AS sub4
WHERE
    NOT is_na
    AND bs * (relpages - est_pages_ff) > 0
ORDER BY
    2, 3, 4
LIMIT 15;','Y','column5::numeric > 50','column5::numeric > 30','High index bloat detected (over 50%). Action strongly recommended to reclaim wasted space.','Bloat ratio exceeds 30%. Consider running REINDEX or investigating table usage patterns.','Y','1 hour',60000,30000,'','Y','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','bloat_ratio',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','added/missing roles and privilege','Detect unauthorized changes to user roles by comparing them to the previous check','','SELECT rolname, rolsuper, rolinherit, rolcreaterole, rolcreatedb, rolcanlogin, rolreplication, rolconnlimit 
FROM pg_roles
ORDER BY rolname;','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','sql','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','added/missing superuser','Detect unauthorized changes to superuser list by comparing them to the previous check','','SELECT rolname FROM pg_roles WHERE rolsuper IS TRUE;','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','commit ratio','Check the commit and rollback rate per second since last call','DO $$ 
BEGIN
  CREATE TABLE IF NOT EXISTS rp_commit_ratio_p (
  epoch_created float8 NULL,
  datname name NULL COLLATE "C",
  xact_commit int8 NULL,
  xact_rollback int8 NULL);

  CREATE TABLE IF NOT EXISTS rp_commit_ratio_c (
  epoch_created float8 NULL,
  datname name NULL COLLATE "C",
  xact_commit int8 NULL,
  xact_rollback int8 NULL);

  TRUNCATE TABLE rp_commit_ratio_p;
  INSERT INTO rp_commit_ratio_p SELECT * FROM rp_commit_ratio_c;

  TRUNCATE TABLE rp_commit_ratio_c;
  INSERT INTO rp_commit_ratio_c SELECT floor(extract(EPOCH FROM now())), s.datname, s.xact_commit, s.xact_rollback
        FROM pg_stat_database s
        JOIN pg_database d ON s.datid = d.oid
        WHERE d.datallowconn; 
END  $$','SELECT datname,ROUND(transdiff/tdiff) AS trans_per_seconds,ROUND(rollsdiff/tdiff) AS rolls_per_sec
FROM 
(SELECT c.datname, (c.epoch_created-p.epoch_created) AS tdiff,(c.xact_commit-p.xact_commit) AS transdiff,(c.xact_rollback-p.xact_rollback) AS rollsdiff
FROM rp_commit_ratio_p p, rp_commit_ratio_c c
where c.datname=p.datname) AS inn WHERE datname NOT IN (''template0'', ''template1'')','Y','column2::numeric > 500','column2::numeric > 100','Very high transaction rate (over 500/sec)','High transaction rate (over 100/sec)','Y','15 minutes',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','added/missing tablespaces','List all tablespaces in the postgres cluster and alert if a tablespace is added or missing compared to the previous check...','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"\\l\" -t" | cut -f1 -d "|" | grep -v template | grep -v "^$")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"SELECT ''$db''||''.''||spcname FROM pg_tablespace WHERE spcname NOT IN (''pg_default'', ''pg_global'')\" -t | tr -d \"|\" | grep -v \"^$\" | sed -e ''s/^[ \t]*//''"
done','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','users connections','This monitor tracks external database connections per user, highlighting cases where a single user dominates total connections, which may indicate suspicious activity.','','SELECT
    usename || '' - '' || datname AS user_database, 
    COUNT(*) AS connection_count_per_user, 
    (SELECT COUNT(*) FROM pg_stat_activity WHERE client_addr IS NOT NULL) AS total_connections
FROM pg_stat_activity
WHERE client_addr IS NOT NULL
GROUP BY user_database
ORDER BY connection_count_per_user DESC;','Y','column2::numeric > (column3::numeric * 0.90)','column2::numeric > (column3::numeric * 0.75)','Critical number of connections detected (above 90% of total)','High number of connections detected (above 75% of total)','Y','1 minute',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','users expired','The monitor helps identify inactive or expired accounts and raises a red alert if any row exists','','SELECT rolname, rolvaliduntil 
FROM pg_roles
WHERE rolvaliduntil IS NOT NULL AND rolvaliduntil < now();','Y','1=1','1=2','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'security'),
	 (1,NULL,'POSTGRES','active/idle sessions','Monitors the number of active and idle database sessions to detect connection spikes or unused session buildup.','','SELECT ''session_amount'' AS key, * FROM 
(SELECT COUNT(*) num_active FROM pg_catalog.pg_stat_activity WHERE state=''active'') a,
(SELECT COUNT(*) num_idle FROM pg_catalog.pg_stat_activity WHERE state<>''active'') i','Y','column2::numeric > 10 OR column3::numeric > 50','column2::numeric > 5 OR column3::numeric > 20','Too many active or idle sessions','High number of active or idle sessions','Y','15 minutes',60000,30000,'','Y','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','active',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','major version','Major version of postgresql instance','','SELECT ''version'' AS key, split_part(version(),'' '',2)::FLOAT, split_part(version(),''on'',2)','Y','1=2','column2::numeric<11','This is a red alert','Version under 11 is not fully supported','Y','1 day',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra');
INSERT INTO app_123monitor.rp_monitors (org_id,node_id,db_type,monitor_name,monitor_description,pre_script,monitor_script,ind_enabled,red_rule,yellow_rule,red_rule_message,yellow_rule_message,ind_send_email_notifications,monitor_interval,runtime_red_threshold,runtime_yellow_threshold,return_code_threshold,ind_status_graph,ind_create_timeline,ind_timeline_full_impact,cmd_type,ind_first_column_unique,ind_alert_on_added_missing,alert_on_added_missing_severity,ind_alert_compare_to_previous_check,alert_compare_to_previous_check_severity,alert_compare_to_previous_check_higher_lower,alert_compare_to_previous_check_percent,ind_break_long_running,ind_compute_baseline,data_reduction_function,renew_alert_every,ind_red_by_row_count,red_by_row_count_option,red_by_row_count_items,ind_yellow_by_row_count,yellow_by_row_count_option,yellow_by_row_count_items,graph_aggregation,graph_aggregation_column,snoozed_until,count_long_running,ind_broken,num_weeks_in_baseline,task_id,"module") VALUES
	 (1,NULL,'POSTGRES','logs and encryption parameters','Detect unauthorized modifications to security-critical settings','','SELECT name, setting
FROM pg_settings 
WHERE name IN (''log_connections'', ''log_disconnections'', ''password_encryption'', ''logging_collector'');','Y','1=2','(column1 != ''password_encryption'' AND column2 = ''off'') OR (settings_name = ''password_encryption'' AND parameter != ''scram-sha-256'')','There is a security issue','Some logging settings are disabled or password encryption is insecure','Y','1 hour',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'security'),
	 (1,NULL,'POSTGRES','autovacuum activity','Ensure the autovacuum process is running effectively','','SELECT schemaname || ''.'' || relname AS relname,
  to_char(last_autovacuum, ''YYYY-MM-DD HH24:MI:SS'') AS last_autovacuum,
  to_char(last_autoanalyze, ''YYYY-MM-DD HH24:MI:SS'') AS last_autoanalyze,
  n_dead_tup,
  n_live_tup
FROM pg_stat_user_tables 
ORDER BY last_autovacuum NULLS FIRST 
LIMIT 20;','Y','column4::numeric > column5::numeric','column4::numeric > (column5::numeric * 0.4)','Dead tuples exceed live tuples!','High dead tuples detected (>40% of live tuples).','Y','15 minutes',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','added/missing replication publications','List all replication publications in the postgres cluster and alert if a replication publication is added or missing compared to the previous check.','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"\\l\" -t" | cut -f1 -d "|" | grep -v template | grep -v "^$")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"SELECT ''$db''||''.''||pubname||''.''||pubowner FROM pg_catalog.pg_publication\" -t | tr -d \"|\" | grep -v \"^$\" | sed -e ''s/^[ \t]*//''"
done','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','top tables by size','This monitor identifies the largest tables in PostgreSQL by total size. It helps optimize storage and performance by highlighting the most space-consuming tables.','','SELECT 
    schemaname || ''.'' || relname AS table_name, 
    ROUND(pg_total_relation_size(relid) / 1024.0 / 1024.0, 4) AS total_size_mb
FROM pg_catalog.pg_statio_user_tables
ORDER BY total_size_mb DESC
LIMIT 15;','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','15 minutes',60000,30000,'','N','Y','Y','sql','Y','N',2,'Y',2,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','connection usage','This monitor tracks the database connection usage, showing the number of active connections and their percentage relative to the maximum allowed. It helps prevent connection exhaustion and optimize resource management.','','SELECT 
    ''connection_usage'' AS monitor_key,
    COUNT(*) AS used_connections,
    (SELECT setting::int FROM pg_settings WHERE name = ''max_connections'') AS max_connections,
    ROUND(100.0 * COUNT(*) / (SELECT setting::int FROM pg_settings WHERE name = ''max_connections''), 2) AS percent_used
FROM pg_stat_activity;','Y','column4::numeric > 90','column4::numeric > 75','Database connections exceed 90%!','Database connections exceed 75% of the limit.','Y','15 minutes',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','lag check','This monitor tracks PostgreSQL replication status, measuring replication lag and identifying whether the server is operating as a primary or standby. It helps ensure replication health and detect delays.','','WITH 
standby_check AS (
    SELECT pg_is_in_recovery() AS is_standby
)
SELECT 
    server_role || ''-'' || COALESCE(application_name, ''local'') AS unique_key,
    server_role,
    state,
    replication_lag_mb,
    replication_lag_seconds
FROM (
    SELECT 
        CASE 
            WHEN s.is_standby THEN ''standby'' 
            ELSE ''primary'' 
        END AS server_role,
        r.state,
        ROUND(
            CASE 
                WHEN s.is_standby 
                THEN pg_wal_lsn_diff(pg_current_wal_lsn(), pg_last_wal_replay_lsn()) / 1024.0 / 1024.0  
                ELSE pg_wal_lsn_diff(pg_current_wal_lsn(), r.replay_lsn) / 1024.0 / 1024.0  
            END, 2
        ) AS replication_lag_mb,
        CASE 
            WHEN s.is_standby 
            THEN EXTRACT(EPOCH FROM now() - pg_last_xact_replay_timestamp())::INT 
            ELSE 0 
        END AS replication_lag_seconds,
        r.application_name,
        s.is_standby
    FROM standby_check s
    LEFT JOIN pg_stat_replication r ON NOT s.is_standby
) subquery;','Y','column6::numeric > 1000','column6::numeric > 10','Replication lag exceeds 1000MB!','Replication lag exceeds 10MB.','Y','15 minutes',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'lag check'),
	 (1,NULL,'POSTGRES','backends','Check the total number of connections in the PostgreSQL cluster','','SELECT res.datname,res.cnt,res.max_connections,ROUND((res.cnt::NUMERIC / res.max_connections) * 100) AS percents    
FROM
(SELECT datname,cnt, (current_setting(''max_connections'')::INT - current_setting(''superuser_reserved_connections'')::INT) AS max_connections
            FROM (
                SELECT d.datname, count(*) cnt
                FROM pg_catalog.pg_stat_activity AS s
                  JOIN pg_catalog.pg_database AS d ON d.oid = s.datid
                WHERE backend_type = ''client backend''
                GROUP BY d.datname
            ) AS s
UNION ALL
SELECT ''All databases'',sum(cnt), (current_setting(''max_connections'')::INT - current_setting(''superuser_reserved_connections'')::INT) AS max_connections
            FROM (
                SELECT d.datname, count(*) cnt
                FROM pg_catalog.pg_stat_activity AS s
                  JOIN pg_catalog.pg_database AS d ON d.oid = s.datid
                WHERE backend_type = ''client backend''
                GROUP BY d.datname
            ) AS s
            GROUP BY  (current_setting(''max_connections'')::INT - current_setting(''superuser_reserved_connections'')::INT)) AS res;','Y','database=''All databases'' and column4::numeric>90','database=''All databases'' and column4::numeric>70','There are more than 90% connections','There are more than 70% connections','Y','15 minutes',60000,30000,'','Y','Y','Y','sql','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','connections_percents',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','added/missing schemas','List all schemas in the postgres cluster and alert if a schema is added or missing compared to the previous check.','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"\\l\" -t" | cut -f1 -d "|" | grep -v template | grep -v "^$")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"SELECT ''$db''||''.''||schema_name FROM information_schema.schemata\" -t | tr -d \"|\" | grep -v \"^$\" | sed -e ''s/^[ \t]*//''"
done','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','backends status','Check the status of all backends','','SELECT state || '' - '' || wait_event_type AS key, wait_event_type, count(*) 
FROM pg_stat_activity
WHERE wait_event_type IS NOT NULL AND state IS NOT NULL
GROUP BY state, wait_event_type
UNION ALL
SELECT state || '' - No waits'', ''No waits'' AS wait_event_type, count(*) 
FROM pg_stat_activity
WHERE wait_event_type IS NULL AND state IS NOT NULL
GROUP BY state
UNION ALL
SELECT ''total active'', NULL, count(*) 
FROM pg_stat_activity
WHERE state = ''active'';','Y','column1=''total active'' and column3::numeric>50','column1=''total active'' and column3::numeric>10','Critical number of active backends detected (more than 50).','High number of active backends detected (more than 10).','Y','15 minutes',60000,30000,'','Y','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','count',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','added/missing sequences','List all sequences in the postgres cluster and alert if a sequence is added or missing compared to the previous check.','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"\\l\" -t" | cut -f1 -d "|" | grep -v template | grep -v "^$")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"SELECT ''$db''||''.''||sequence_schema||''.''||sequence_name FROM information_schema.sequences ORDER BY sequence_name\" -t | tr -d \"|\" | grep -v \"^$\" | sed -e ''s/^[ \t]*//''"
done','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra');
INSERT INTO app_123monitor.rp_monitors (org_id,node_id,db_type,monitor_name,monitor_description,pre_script,monitor_script,ind_enabled,red_rule,yellow_rule,red_rule_message,yellow_rule_message,ind_send_email_notifications,monitor_interval,runtime_red_threshold,runtime_yellow_threshold,return_code_threshold,ind_status_graph,ind_create_timeline,ind_timeline_full_impact,cmd_type,ind_first_column_unique,ind_alert_on_added_missing,alert_on_added_missing_severity,ind_alert_compare_to_previous_check,alert_compare_to_previous_check_severity,alert_compare_to_previous_check_higher_lower,alert_compare_to_previous_check_percent,ind_break_long_running,ind_compute_baseline,data_reduction_function,renew_alert_every,ind_red_by_row_count,red_by_row_count_option,red_by_row_count_items,ind_yellow_by_row_count,yellow_by_row_count_option,yellow_by_row_count_items,graph_aggregation,graph_aggregation_column,snoozed_until,count_long_running,ind_broken,num_weeks_in_baseline,task_id,"module") VALUES
	 (1,NULL,'POSTGRES','users check','Check change in users list','','SELECT * FROM pg_user','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','sql','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'security'),
	 (1,NULL,'POSTGRES','temp files','Check the size of temporary files created by queries. Temporary files are often created when memory settings are too low or when large queries are executed. High usage may indicate inefficient queries or suboptimal memory settings.','','SELECT datname, temp_files, ROUND(temp_bytes/1024/1024) FROM pg_stat_database 
WHERE datname NOT IN (''template0'', ''template1'')
UNION ALL 
SELECT ''total in mb'', SUM(temp_files), ROUND(SUM(temp_bytes)/1024/1024) 
FROM pg_stat_database','Y','column1=''total in mb'' and column3::numeric>2000','column1=''total in mb'' and column3::numeric>1000','Temporary file usage exceeded 2 GB across all databases — investigate large queries or increase work_mem setting.','Temporary file usage exceeded 1 GB across all databases — this may indicate suboptimal queries or memory settings.','Y','1 day',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','uptime','This monitor tracks the database uptime in seconds, helping to identify how long the PostgreSQL instance has been running without a restart.','','SELECT ''uptime'' AS name, date_trunc(''second'', current_timestamp - pg_postmaster_start_time()) AS uptime;','Y','EXTRACT(EPOCH FROM column2::INTERVAL) < 400','1=2','Database uptime is too low, indicating a recent restart!','This is a yellow alert','Y','5 minutes',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','replication slot','Check the total number of replication slots in the PostgreSQL cluster','','SELECT slot_type, COUNT(*), current_setting(''max_replication_slots'') AS max_slots, ROUND((COUNT(*)/ current_setting(''max_replication_slots'')::NUMERIC)*100) AS slot_percent FROM pg_replication_slots GROUP BY slot_type
UNION ALL 
SELECT ''total slots'', COUNT(*),current_setting(''max_replication_slots''), ROUND((COUNT(*)/ current_setting(''max_replication_slots'')::NUMERIC)*100) FROM pg_replication_slots','Y','column1=''total slots'' and column4::numeric>=90','column1=''total slots'' and column4::numeric>=70','There are more than 90% replication slots','There are more than 70% replication slots','Y','1 hour',60000,30000,'','Y','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','slot_percent',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','unused indexes','This monitor detects unused indexes in PostgreSQL that have never been scanned (idx_scan = 0). It helps identify and remove unnecessary indexes to optimize database performance and storage.','','SELECT 
    ui.schemaname || ''.'' || ui.relname || ''.'' || ui.indexrelname AS table_index_name,
    ui.idx_scan,
    CASE 
        WHEN ci.indisprimary OR ci.indisunique THEN ''Yes''
        ELSE ''No''
    END AS is_primary_or_unique
FROM pg_stat_user_indexes ui
JOIN pg_index ci ON ui.indexrelid = ci.indexrelid
WHERE ui.idx_scan = 0;','Y','1=2','column3 != ''Yes''','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','added stat statements','Collect postgresql query statistics. Monitors top SQL queries from pg_stat_statements by execution time share and average duration. Alerts highlight slow or high-impact queries affecting overall performance.','','WITH total AS (
    SELECT ROUND(SUM(total_exec_time)) AS total
    FROM pg_stat_statements
)
SELECT 
    pss.queryid,
    rol.rolname AS username,
    db.datname AS database_name,
    LEFT(pss.query, 300) AS query_snippet,
    pss.calls,
    ROUND(pss.total_exec_time) AS total_exec_time,
    ROUND(pss.mean_exec_time) AS mean_exec_time,
    pss.rows,
    ROUND((pss.total_exec_time / total.total) * 100) AS share
FROM 
    pg_stat_statements AS pss
JOIN 
    pg_roles AS rol ON pss.userid = rol.oid
JOIN 
    pg_database AS db ON pss.dbid = db.oid,
    total
ORDER BY 
    total_exec_time DESC
LIMIT 10;','Y','column9::numeric >= 10 OR column7::numeric >= 60000','column9::numeric >= 5 OR column7::numeric >= 5000','Query dominates system time or average execution exceeds 60 seconds.','Query has high execution share or average execution exceeds 5 seconds.','Y','15 minutes',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','constraints','Check constraints that not validate','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -qAt -c \"SELECT datname FROM pg_database WHERE datistemplate = false\"")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -qAt -c \"
        SELECT ''$db'' || ''.'' || conname, nspname, condeferrable, condeferred, convalidated
        FROM pg_constraint c
        JOIN pg_namespace s ON c.connamespace = s.oid
        WHERE NOT convalidated
    \""
done','Y','1=2','1=1','This is a red alert','Validation is disabled for this constraint. Please review and validate it if necessary.','Y','1 hour',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','extensions versions','Check all extensions installed in all databases (including templates)','','SELECT
    current_database() || ''.'' || e.extname AS name,
    e.extversion AS installed_version,
    x.default_version
FROM
    pg_catalog.pg_extension e
JOIN
    pg_catalog.pg_available_extensions x ON e.extname = x.name
WHERE
    e.extversion != x.default_version;','Y','1=2','column3 != column2','This is a red alert','The current version is not the default version available on the instance','Y','1 hour',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','Hit ratio','Check the cache hit ratio on the postgres cluster','','SELECT d.datname, blks_hit, blks_read, ROUND((blks_hit/ (blks_hit+blks_read)::NUMERIC)*100)
        FROM pg_stat_database sd
          JOIN pg_database d ON d.oid = sd.datid
        WHERE d.datallowconn AND NOT d.datistemplate
        ORDER BY datname','Y','column4::numeric<70','column4::numeric<90','Cache hit ratio is critically low','Cache hit ratio is low','Y','15 minutes',60000,30000,'','Y','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','Hit ratio',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','pg_stat_statements_1m','','SELECT populate_pg_stat_statements_current(''1m'');','SELECT
    ''1 minute'' AS period,
    query AS query_text,
    delta_calls AS calls_difference,
    delta_time AS total_time_difference_ms,
    avg_time AS avg_query_time_ms
FROM pgss_cur_1m','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 minute',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'');
INSERT INTO app_123monitor.rp_monitors (org_id,node_id,db_type,monitor_name,monitor_description,pre_script,monitor_script,ind_enabled,red_rule,yellow_rule,red_rule_message,yellow_rule_message,ind_send_email_notifications,monitor_interval,runtime_red_threshold,runtime_yellow_threshold,return_code_threshold,ind_status_graph,ind_create_timeline,ind_timeline_full_impact,cmd_type,ind_first_column_unique,ind_alert_on_added_missing,alert_on_added_missing_severity,ind_alert_compare_to_previous_check,alert_compare_to_previous_check_severity,alert_compare_to_previous_check_higher_lower,alert_compare_to_previous_check_percent,ind_break_long_running,ind_compute_baseline,data_reduction_function,renew_alert_every,ind_red_by_row_count,red_by_row_count_option,red_by_row_count_items,ind_yellow_by_row_count,yellow_by_row_count_option,yellow_by_row_count_items,graph_aggregation,graph_aggregation_column,snoozed_until,count_long_running,ind_broken,num_weeks_in_baseline,task_id,"module") VALUES
	 (1,NULL,'POSTGRES','pg_stat_statements_5m','','SELECT populate_pg_stat_statements_current(''5m'');','SELECT
    ''5 minutes'' AS period,
    query AS query_text,
    delta_calls AS calls_difference,
    delta_time AS total_time_difference_ms,
    avg_time AS avg_query_time_ms
FROM pgss_cur_5m','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','5 minutes',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,''),
	 (1,NULL,'POSTGRES','pg_stat_statements_15m','','SELECT populate_pg_stat_statements_current(''15m'');','SELECT
    ''15 minutes'' AS period,
    query AS query_text,
    delta_calls AS calls_difference,
    delta_time AS total_time_difference_ms,
    avg_time AS avg_query_time_ms
FROM pgss_cur_15m','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','15 minutes',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,''),
	 (1,NULL,'POSTGRES','pg_stat_statements_1h','','SELECT populate_pg_stat_statements_current(''1h'');','SELECT
    ''1 hour'' AS period,
    query AS query_text,
    delta_calls AS calls_difference,
    delta_time AS total_time_difference_ms,
    avg_time AS avg_query_time_ms
FROM pgss_cur_1h','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','N','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,''),
	 (1,NULL,'POSTGRES','index usage','This monitor checks index usage efficiency across all databases in a PostgreSQL instance, identifying tables with low index utilization to optimize query performance.','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"\\l\" -t" | cut -f1 -d "|" | grep -v template | grep -v "^$")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"SELECT ''$db''||''.''||relname, idx_scan, seq_scan, round((100 * idx_scan / nullif(seq_scan + idx_scan, 0)), 2) FROM pg_stat_user_tables ORDER BY 4 ASC;\" -t | tr -d \"|\" | grep -v \"^$\" | sed -e ''s/^[ \t]*//''"
done','Y','1=2','1=1','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','ssh','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','added/missing tables','List all tables in the postgres cluster and alert if a table is added or missing compared to the previous check.','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -qAt -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"SELECT datname FROM pg_database WHERE datistemplate = false\"")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -qAt -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"
    SET client_min_messages TO warning;

    CREATE TABLE IF NOT EXISTS monitor_tables_snapshot (
        schemaname TEXT,
        tablename TEXT,
        PRIMARY KEY (schemaname, tablename)
    );

    WITH current_tables AS (
        SELECT schemaname, tablename
        FROM pg_tables
        WHERE schemaname NOT IN (''pg_catalog'', ''information_schema'')
    ),
    new_tables AS (
        SELECT schemaname, tablename, ''new'' AS status
        FROM current_tables
        EXCEPT
        SELECT schemaname, tablename, ''new'' FROM monitor_tables_snapshot
    ),
    dropped_tables AS (
        SELECT schemaname, tablename, ''dropped'' AS status
        FROM monitor_tables_snapshot
        EXCEPT
        SELECT schemaname, tablename, ''dropped'' FROM current_tables
    )
    SELECT ''$db.'' || schemaname || ''.'' || tablename || ''|'' || status
    FROM new_tables
    UNION ALL
    SELECT ''$db.'' || schemaname || ''.'' || tablename || ''|'' || status
    FROM dropped_tables;

    TRUNCATE monitor_tables_snapshot;
    INSERT INTO monitor_tables_snapshot
    SELECT schemaname, tablename FROM pg_tables
    WHERE schemaname NOT IN (''pg_catalog'', ''information_schema'');
    \""
done','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','blocking queries','This monitor detects blocking queries in PostgreSQL that cause other queries to wait due to locks. It helps identify long-running locks and potential performance bottlenecks.','','SELECT DISTINCT ON (blocked.pid)
	blocked.pid AS blocked_pid,
	blocking.pid AS blocking_pid,
	blocked.query AS blocked_query,
    blocking.query AS blocking_query,
    ROUND(EXTRACT(EPOCH FROM (now() - blocked.query_start))) AS blocking_duration_seconds
FROM pg_stat_activity blocked
JOIN pg_stat_activity blocking 
    ON blocked.wait_event IS NOT NULL
    AND blocked.wait_event_type = ''Lock''
    AND blocked.state = ''active'' 
ORDER BY blocked.pid, blocking_duration_seconds DESC;','Y','column5::numeric > 100','column5::numeric > 10','Query blocking for over 100s!','Query blocking for over 10s.','Y','1 minute',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','database size','Check the variation of database sizes, and return the size of every databases','','SELECT datname, ROUND(pg_database_size(pg_database.datname)/1024/1024) AS size_in_mb, oid, datallowconn, datconnlimit FROM pg_database 
WHERE datname NOT IN (''template0'', ''template1'') 
ORDER BY size_in_mb DESC LIMIT 5','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','Y','Y','Y','sql','Y','N',2,'Y',3,'higher',4,'Y','N','average','day','N','above',0,'N','above',0,'average','size_in_mb',NULL,NULL,NULL,NULL,NULL,'performance'),
	 (1,NULL,'POSTGRES','added/missing views','List all views in the postgres cluster and alert if a view is added or missing compared to the previous check.','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"\\l\" -t" | cut -f1 -d "|" | grep -v template | grep -v "^$")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"SELECT ''$db''||''.''||table_schema||''.''||table_name FROM information_schema.views WHERE table_schema NOT IN (''information_schema'', ''pg_catalog'') ORDER BY table_schema, table_name\" -t | tr -d \"|\" | grep -v \"^$\" | sed -e ''s/^[ \t]*//''"
done','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','database connection issues','Check the databases connection issues','','SELECT datname,ROUND(pg_database_size(pg_database.datname)/1024/1024)  AS size_in_mb,oid,datallowconn,datconnlimit FROM pg_database','Y','column5::numeric >= 0 AND datconnlimit <= 5','column4=''false''','Database has a critically low connection limit','Connections are disabled for this database by configuration','Y','1 minute',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','added/missing functions','List only agg/normal/procedures/trigger/window functions in the postgres cluster and alert if a function is added or missing compared to the previous check.','','for db in $(sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d postgres --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"\\l\" -t" | cut -f1 -d "|" | grep -v template | grep -v "^$")
do
    sudo -u postgres bash -c "export PGPASSWORD=$#DBPWD#$; psql -d $db --host $#HOST#$ --port $#PORT#$ --user $#DBUSER#$ -c \"SELECT ''$db''||''.''||p.proname AS function_name, n.nspname AS function_schema, l.lanname AS function_language FROM pg_proc p LEFT JOIN pg_namespace n ON p.pronamespace = n.oid LEFT JOIN pg_language l ON p.prolang = l.oid LEFT JOIN pg_type t ON t.oid = p.prorettype WHERE n.nspname NOT IN (''pg_catalog'', ''information_schema'') ORDER BY function_schema, function_name\" -t | tr -d \"|\" | grep -v \"^$\" | sed -e ''s/^[ \t]*//''"
done','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','ssh','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra');
INSERT INTO app_123monitor.rp_monitors (org_id,node_id,db_type,monitor_name,monitor_description,pre_script,monitor_script,ind_enabled,red_rule,yellow_rule,red_rule_message,yellow_rule_message,ind_send_email_notifications,monitor_interval,runtime_red_threshold,runtime_yellow_threshold,return_code_threshold,ind_status_graph,ind_create_timeline,ind_timeline_full_impact,cmd_type,ind_first_column_unique,ind_alert_on_added_missing,alert_on_added_missing_severity,ind_alert_compare_to_previous_check,alert_compare_to_previous_check_severity,alert_compare_to_previous_check_higher_lower,alert_compare_to_previous_check_percent,ind_break_long_running,ind_compute_baseline,data_reduction_function,renew_alert_every,ind_red_by_row_count,red_by_row_count_option,red_by_row_count_items,ind_yellow_by_row_count,yellow_by_row_count_option,yellow_by_row_count_items,graph_aggregation,graph_aggregation_column,snoozed_until,count_long_running,ind_broken,num_weeks_in_baseline,task_id,"module") VALUES
	 (1,NULL,'POSTGRES','added/missing databases','List all databases in the postgres cluster and alert if a database is added or missing compared to the previous chec','','SELECT datname,ROUND(pg_database_size(pg_database.datname)/1024/1024) AS size_in_mb,oid,datallowconn,datconnlimit FROM pg_database 
WHERE datname NOT IN (''template0'', ''template1'')','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','sql','Y','Y',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','connection','Check connection to database','','SELECT ''Responding''','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 hour',60000,30000,'','N','Y','Y','sql','Y','N',2,'N',3,'higher',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra'),
	 (1,NULL,'POSTGRES','parameters','Check the most important settings','','SELECT name,setting,short_desc FROM pg_settings where source !=''default'';
','Y','1=2','1=2','This is a red alert','This is a yellow alert','Y','1 day',60000,30000,'','N','Y','Y','sql','Y','Y',2,'Y',2,'different',100,'Y','N','average','day','N','above',0,'N','above',0,'average','',NULL,NULL,NULL,NULL,NULL,'infra');
