
from rest_framework import generics
from rest_framework.permissions import IsAuthenticated
from clusterCore.models import c123_node
from .serializer import c123_CreatePostgresPodSerializer
from clusterCore.api.serializer import get_create_node_response
class c123_CreatePostgresPodView(generics.CreateAPIView):
    permission_classes = [IsAuthenticated]
    queryset = c123_node.objects.all()
    serializer_class = c123_CreatePostgresPodSerializer
    def create(self, request, *args, **kwargs):
        return get_create_node_response(self, request, *args, **kwargs)