import { Tooltip } from "primereact/tooltip";
import restApi from "../../assets/images/restapi.png";

export default function ApiBar(props)
{

    return (
        <div className="field grid">
            <div className="col">
                <img alt="rest api" id = {props.id} className="rest-api" src={restApi} onClick={props.onClick} />
                <Tooltip target=".rest-api" showEvent="click">
                    {props.tooltip}
                </Tooltip>
            </div>

        </div>);
    
}