import config from "../../../config";
const constraints = {
    username: {
        presence: {
            message: "Username is required field.",
            allowEmpty: false
        },
        format: {
            pattern: config.usernameRegex,
            message: "Username has invalid format."
        }
    },
    password: {
        presence: {
            message: "Password is required field.",
            allowEmpty: false
        },
        format: {
            pattern: config.passwordRegex,
            message: "Password has invalid format."
        }
    },
    password2: 
    {

        equality: 
        {
            attribute: "password",
            message: "Passwords does not match."

        }

    }
    
}

export default constraints;