import { Dialog } from "primereact/dialog";
import { InputTextarea } from 'primereact/inputtextarea';

const ErrorDetailsDialog =  (props) => 
{

  
  return (<Dialog
    className='error-details'
    header={`Error details`}
    visible={props.visible}
    dismissableMask
    style={{ width: '40vw', maxHeight: '90%'}}
    onHide={props.onHide}>
    <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
    <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">

    <div className="field grid">
                    <label className="col-fixed">{`Message :`}</label>
                      <div className="col">
                      <InputTextarea value={props.message.join ? props.message.join("\n") : props.message} rows={5} cols={30} />
                    </div>
                    </div>
        </div>

        </div>

        </Dialog>
)

}

export default ErrorDetailsDialog;
