import config from "../../../config";

const constraints = {
    key: {
        presence: {
            message: "Key is required field.",
            allowEmpty: false
        }
    },

    ip: {
        presence: {
            message: "IP is required field.",
            allowEmpty: false
        },
        format: {
            pattern: config.hostNameRegex,
            message: "ip has invalid format."
        }
    },
}

export default constraints;