import config from "../../../config";

const constraints = {
    name: {

        presence: {
            message: "Name is required field",
            allowEmpty: false
        },
        format: {
            pattern: config.mysqlNameRegex,
            message: "Name has invalid format."
        },
    },

    port: {
        presence: {
            message: "port is required field.",
            allowEmpty: false
        },
        numericality: {
            greaterThan: 0,
            lessThanOrEqualTo: 65535,
        }
    },
}

export default constraints;