import config from "../../../config";

const constraints = {
    fileDestination: {
        presence: {
            message: "File destination is required field",
            allowEmpty: false
        },
        format: {
            pattern: config.pathRegex,
            message: "File Destination has invalid format."
        }
    },
    name: {

        presence: {
            message: "PDB name is required field",
            allowEmpty: false
        },
        format: {
            pattern: config.oracleNameRegex,
            message: "PDB name has invalid format."
        },
    },
    attachStandbys: {
        presence: {
            message: "Attach standbys is required field",
            allowEmpty: false
        },
    },
}

export default constraints;