import { Dialog } from "primereact/dialog";
import moment from "moment";


export const detailsPDBDialog =  (props) => 
{

  
  return (<Dialog
    className='pdb-details'
    header={`${props.node.location} details:`}
    visible={props.visible}
    style={{ width: '50vw', maxHeight: "90%"}}
    onHide={props.onHide}>
    <div style={{ display: "flex", paddingBottom: "10px" }} className="form-container">
    <div style={{ flex: 1, padding: "10px" }} className="p-fluid form-container">
    
    <div className="field grid">
                    <label className="col-fixed">{`PDB name:`}</label>
                      <div className="col">
                        {props.node.name}

                    </div>
                    </div>
  

                    <div className="field grid">
                    <label className="col-fixed">{`PDB status:`}</label>
                      <div className="col">
                        {props.node.status ? props.node.status : "available"}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`PDB size:`}</label>
                      <div className="col">
                      {props?.node?.display_size}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Created by :`}</label>
                      <div className="col">
                        { props.node.created_by}
                    </div>
                    </div>

                    <div className="field grid">
                    <label className="col-fixed">{`Creation date:`}</label>
                      <div className="col">
                      { moment(props.node.created_date).format("MMM DD,YYYY, hh:mm A")}
                    </div>
                    </div>
        </div>

        </div>
        </Dialog>
)


};

export default detailsPDBDialog;
