import { all } from "redux-saga/effects";
import app from "./app/sagas";
import status from "./status/sagas";
import log from "./log/sagas";
import config from "./config/sagas";
import settings from "./settings/sagas";
import clusUp from "./clusterUpdate/sagas";
import signUp from "./signup/sagas";
import userUpdate from "./userUpdate/sagas";
import toasts from "./toasts/sagas";
import layout from "./layout/sagas";
import monitoring from './monitoring/sagas';
import taskNotifications from "./taskNotifications/sagas"
import downloadFile from "./downloadFile/sagas"
export default function* sagas() {
    yield all([
        ...app,
        ...status,
        ...log,
        ...config,
        ...settings,
        ...clusUp,
        ...signUp,
        ...userUpdate,
        ...toasts,
        ...layout,
        ...taskNotifications,
        ...monitoring,
        ...downloadFile
    ]);
}
