import { useRef } from 'react'
import { useResize } from './useResize';
export default function Resizable({children}) {
  const ref = useRef();
  const { initResize} = useResize(ref);
  return (
    <div className='resizable-div' ref={ref} style = {{overflow: 'auto'}}>
      
      {children}
      <i onMouseDown = {initResize}  className='pi pi-window-maximize resizable-thumb'/>
    </div>
  )
}