import LazyTimeline from './LazyTimeline';

export const timelineBodyTemplate = (item, history_per_alerts, interval) => {
  return (
      <LazyTimeline
          item={item}
          history_per_alerts={history_per_alerts}
          interval={interval}
      />
  );
};

export const rangeByMonitorInterval = (interval) => {
    switch(interval)
    {
        case 0:
            return {'unit': 'minutes', 'amount': 10}
        case 1:
            return {'unit': 'hours', 'amount': 1}
        case 2:
            return {'unit': 'hours', 'amount': 6}
        case 3:
            return {'unit': 'days', 'amount': 1}
        case 4:
            return {'unit': 'days', 'amount': 7}
        default:
            return {'unit': 'days', 'amount': 7}
    }
}

export default timelineBodyTemplate;
