import {useState, useEffect } from "react";
export const useIsOverflow = (ref) => {
    const [isOverflow,setIsOverflow] = useState(false);
  
    useEffect(() => ref.current && setIsOverflow(ref.current.offsetWidth < ref.current.scrollWidth), [ref]);
  
    return isOverflow;
  };